/// <reference types="node" />
import { EventEmitter } from 'events';
import { StrictEventEmitter } from './EventEmitterTypesHelper';
import { IBlockingQueueOptions, IEnqueueResult, QueueFn } from './types';
interface IBlockingQueueEvents {
    idle: void;
    empty: void;
}
type MessageEmitter = StrictEventEmitter<EventEmitter, IBlockingQueueEvents>;
declare const BlockingQueue_base: new () => MessageEmitter;
export declare class BlockingQueue extends BlockingQueue_base {
    private readonly _options;
    private readonly _queue;
    private readonly _boundNext;
    private _activeCount;
    constructor(options: IBlockingQueueOptions);
    enqueue<T, P extends any[]>(fn: QueueFn<T, P>, ...args: P): IEnqueueResult<T>;
    get activeCount(): number;
    get pendingCount(): number;
    private _next;
    private _run;
    private _getPromiseParts;
}
export {};
